<?php
/** 
 * Plugin recomendations
 **/
global $piemont_theme_options;

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

require_once ('class-tgm-plugin-activation.php');

add_action( 'tgmpa_register', 'piemont_register_required_plugins' );

function piemont_register_required_plugins() {

    /**
     * Array of plugin arrays. Required keys are name and slug.
     * If the source is NOT from the .org repo, then source is also required.
     */
    $plugins = array(
        array(
            'name'                  => 'Piemont Custom Metaboxes', // The plugin name
            'slug'                  => 'cmb2', // The plugin slug (typically the folder name)
            'source'                => get_stylesheet_directory() . '/inc/plugins/cmb2.zip', // The plugin source
            'required'              => true, // If false, the plugin is only 'recommended' instead of required
            'version'               => '2.0.8', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
            'force_activation'      => false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
            'force_deactivation'    => false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
            'external_url'          => '', // If set, overrides default API URL and points to an external URL
        ),    
        array(
            'name'                  => 'WooCommerce', // The plugin name
            'slug'                  => 'woocommerce', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'Piemont Translation Manager', // The plugin name
            'slug'                  => 'loco-translate', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'Instagram Feed', // The plugin name
            'slug'                  => 'instagram-feed', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'MailChimp for WordPress (Newsletter signup)', // The plugin name
            'slug'                  => 'mailchimp-for-wp', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'WordPress LightBox', // The plugin name
            'slug'                  => 'responsive-lightbox', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'Contact Form 7', // The plugin name
            'slug'                  => 'contact-form-7', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'Regenerate Thumbnails', // The plugin name
            'slug'                  => 'regenerate-thumbnails', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        ),
        array(
            'name'                  => 'WP Retina 2x', // The plugin name
            'slug'                  => 'wp-retina-2x', // The plugin slug (typically the folder name)
            'required'              => false, // If false, the plugin is only 'recommended' instead of required
        )

    );

    /**
     * Array of configuration settings. Amend each line as needed.
     * If you want the default strings to be available under your own theme domain,
     * leave the strings uncommented.
     * Some of the strings are added into a sprintf, so see the comments at the
     * end of each line for what each argument will be.
     */
    $config = array(
        'domain'            => 'piemont',           // Text domain - likely want to be the same as your theme.
        'default_path'      => '',                          // Default absolute path to pre-packaged plugins
        'menu'              => 'install-required-plugins',  // Menu slug
        'has_notices'       => true,                        // Show admin notices or not
        'dismissable'  => true,
        'is_automatic'      => true,                       // Automatically activate plugins after installation or not
        'message'           => '',                          // Message to output right before the plugins table
        'strings'           => array(
            'page_title'                                => __( 'Install Required Plugins', 'piemont' ),
            'menu_title'                                => __( 'Install Plugins', 'piemont' ),
            'installing'                                => __( 'Installing Plugin: %s', 'piemont' ), // %1$s = plugin name
            'oops'                                      => __( 'Something went wrong with the plugin API.', 'piemont' ),
            'notice_can_install_required'               => _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' , 'piemont' ), // %1$s = plugin name(s)
            'notice_can_install_recommended'            => _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends the following plugins: %1$s.', 'piemont' ), // %1$s = plugin name(s)
            'notice_cannot_install'                     => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.', 'piemont' ), // %1$s = plugin name(s)
            'notice_can_activate_required'              => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.', 'piemont' ), // %1$s = plugin name(s)
            'notice_can_activate_recommended'           => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.', 'piemont' ), // %1$s = plugin name(s)
            'notice_cannot_activate'                    => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.', 'piemont' ), // %1$s = plugin name(s)
            'notice_ask_to_update'                      => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.', 'piemont' ), // %1$s = plugin name(s)
            'notice_cannot_update'                      => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.', 'piemont' ), // %1$s = plugin name(s)
            'install_link'                              => _n_noop( 'Begin installing plugin', 'Begin installing plugins', 'piemont' ),
            'activate_link'                             => _n_noop( 'Activate installed plugin', 'Activate installed plugins', 'piemont'),
            'return'                                    => __( 'Return to Required Plugins Installer', 'piemont' ),
            'plugin_activated'                          => __( 'Plugin activated successfully.', 'piemont' ),
            'complete'                                  => __( 'All plugins installed and activated successfully. %s', 'piemont' ), // %1$s = dashboard link
            'nag_type'                                  => 'updated' // Determines admin notice type - can only be 'updated' or 'error'
        )
    );

    tgmpa( $plugins, $config );

}

/* Widgets */

function piemont_widgets_init() {
    global $piemont_theme_options;
    
    register_sidebar(
      array(
        'name' => __( 'Left/Right sidebar', 'piemont' ),
        'id' => 'main-sidebar',
        'description' => __( 'Widgets in this area will be shown in the left or right site column.', 'piemont' )
      )
    );

    register_sidebar(
      array(
        'name' => __( 'Offcanvas Right sidebar', 'piemont' ),
        'id' => 'offcanvas-sidebar',
        'description' => __( 'Widgets in this area will be shown in the right floating offcanvas menu sidebar that can be opened by toggle button in header. You can enable this sidebar in theme control panel.', 'piemont' )
      )
    );

    register_sidebar(
      array(
        'name' => __( 'Footer light sidebar', 'piemont' ),
        'id' => 'footer-sidebar',
        'description' => __( 'Widgets in this area will be shown in site footer in 4 column.', 'piemont' )
      )
    );

    register_sidebar(
      array(
        'name' => __( 'Footer dark sidebar', 'piemont' ),
        'id' => 'footer-sidebar-2',
        'description' => __( 'Widgets in this area will be shown in site footer in 4 column after Footer sidebar #1.', 'piemont' )
      )
    );

    // Custom widgets
    register_widget('Piemont_Widget_Recent_Posts');
    register_widget('Piemont_Widget_Recent_Comments');
}

add_action( 'widgets_init', 'piemont_widgets_init' );

add_filter('widget_text', 'do_shortcode');

// Customisation Menu Links
class piemont_description_walker extends Walker_Nav_Menu{
      function start_el(&$output, $item, $depth = 0, $args = Array(), $current_object_id = 0 ){
           global $wp_query;
           $indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
           $class_names = $value = '';
           $classes = empty( $item->classes ) ? array() : (array) $item->classes;
           $class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item ) );
          
           $add_class = '';
           
           $post = get_post($item->object_id);          

               $class_names = ' class="'.$add_class.' '. esc_attr( $class_names ) . '"';
               $output .= $indent . '<li id="menu-item-'. $item->ID . '"' . $value . $class_names .'>';
               $attributes  = ! empty( $item->attr_title ) ? ' title="'  . esc_attr( $item->attr_title ) .'"' : '';
               $attributes .= ! empty( $item->target )     ? ' target="' . esc_attr( $item->target     ) .'"' : '';
               $attributes .= ! empty( $item->xfn )        ? ' rel="'    . esc_attr( $item->xfn        ) .'"' : '';

                    $attributes .= ! empty( $item->url )        ? ' href="'   . esc_attr( $item->url        ) .'"' : '';

                if (is_object($args)) {
                    $item_output = $args->before;
                    $item_output .= '<a'. $attributes .'>';
                    $item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID );
                    $item_output .= $args->link_after;
                    if($item->description !== '') {
                        $item_output .= '<span>'.$item->description.'</span>';
                    }
                    
                    $item_output .= '</a>';
                    $item_output .= $args->after;
                    $output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );

                }
     }
}

function piemont_custom_favicon() {
    global $piemont_theme_options;

    if(isset($piemont_theme_options['favicon_image']) && $piemont_theme_options['favicon_image']['url'] <> '') {
      echo '<link rel="icon" type="image/png" href="'.$piemont_theme_options['favicon_image']['url'].'" />';
    }
}
add_action( 'wp_head' , 'piemont_custom_favicon' );

function piemont_google_fonts_url() {

    global $piemont_theme_options;

    $font_url = '';
    $font_header = '';
    $font_body = '';
    $font_additional = '';

    // Demo settings
    if ( defined('DEMO_MODE') && isset($_GET['header_font']) ) {
      $piemont_theme_options['header_font']['font-family'] = $_GET['header_font'];
    }
    if ( defined('DEMO_MODE') && isset($_GET['body_font']) ) {
      $piemont_theme_options['body_font']['font-family'] = $_GET['body_font'];
    }
    if ( defined('DEMO_MODE') && isset($_GET['additional_font']) ) {
      $piemont_theme_options['additional_font']['font-family'] = $_GET['additional_font'];
    }

    if(!isset($piemont_theme_options['font_google_disable']) || $piemont_theme_options['font_google_disable'] == false) {

        // Header font
        if(isset($piemont_theme_options['header_font'])) {
            $font_header = $piemont_theme_options['header_font']['font-family'];

            if(isset($piemont_theme_options['header_font_options'])) {
                $font_header = $font_header.':'.$piemont_theme_options['header_font_options'];
            }
        }
        // Body font
        if(isset($piemont_theme_options['body_font'])) {
            $font_body = '|'.$piemont_theme_options['body_font']['font-family'];

            if(isset($piemont_theme_options['body_font_options'])) {
                $font_body = $font_body.':'.$piemont_theme_options['body_font_options'];
            }
        }
        // Additional font
        if(isset($piemont_theme_options['additional_font_enable']) && $piemont_theme_options['additional_font_enable']) {
            if(isset($piemont_theme_options['additional_font'])) {
                $font_additional = '|'.$piemont_theme_options['additional_font']['font-family'].'|';
            }
        }

        // Build Google Fonts request
        $font_url = add_query_arg( 'family', urlencode( $font_header.$font_body.$font_additional ), "//fonts.googleapis.com/css" );

    }
    
    return $font_url;
}

// Custom layout functions
function piemont_header_promo_show() {
    global $piemont_theme_options;

    echo '<div class="header-promo-content">'.($piemont_theme_options['header_banner_editor']).'</div>';
}

function piemont_logo_show() {
    ?>
    <div class="logo">
    <a class="logo-link" href="<?php echo home_url(); ?>"><img src="<?php echo get_header_image(); ?>" alt="<?php bloginfo('name'); ?>"></a>
    <?php if(get_bloginfo('description')!=='') {
      echo '<div class="header-blog-info">';
      bloginfo('description');
      echo '</div>';
    }
    ?>
    </div>
    <?php
}

function piemont_menu_below_header_show() {
    global $piemont_theme_options;
    
    // Demo settings
    if ( defined('DEMO_MODE') && isset($_GET['header_menu_style']) ) {
      $piemont_theme_options['header_menu_style'] = esc_html($_GET['header_menu_style']);
    }
    if ( defined('DEMO_MODE') && isset($_GET['header_menu_align']) ) {
      $piemont_theme_options['header_menu_align'] = esc_html($_GET['header_menu_align']);
    }

    // MainMenu styles
    $menu_add_class = '';

    if(isset($piemont_theme_options['header_menu_style'])) {
        $menu_add_class = ' '.$piemont_theme_options['header_menu_style'];
    } 
    if(isset($piemont_theme_options['header_menu_font_decoration'])) {
        $menu_add_class .= ' mainmenu-'.esc_html($piemont_theme_options['header_menu_font_decoration']);
    }
    if(isset($piemont_theme_options['header_menu_font_size'])) {
        $menu_add_class .= ' mainmenu-'.esc_html($piemont_theme_options['header_menu_font_size']);
    }
    if(isset($piemont_theme_options['header_menu_arrow_style'])) {
        $menu_add_class .= ' mainmenu-'.esc_html($piemont_theme_options['header_menu_arrow_style']);
    }
    if((isset($piemont_theme_options['header_menu_align'])) && ($piemont_theme_options['header_menu_align'] == 'menu_center')) {
        $menu_add_class .= ' menu-center';
    }

    ?>

    <?php
    // Main Menu

    $menu = wp_nav_menu(
        array (
            'theme_location'  => 'primary',
            'echo' => FALSE,
            'fallback_cb' => '__return_false'
        )
    );

    if (!empty($menu)):
 
    ?>
    <div class="mainmenu-belowheader<?php echo esc_attr($menu_add_class); ?>">
        <div class="mainmenu-belowheader-spacer"></div>
        <div id="navbar" class="navbar navbar-default clearfix">
          <div class="navbar-inner">
              <div class="container">
             
              <div class="navbar-toggle" data-toggle="collapse" data-target=".collapse">
                <?php _e( 'Menu', 'piemont' ); ?>
              </div>

              <?php
             
                 wp_nav_menu(array(
                  'theme_location'  => 'primary',
                  'container_class' => 'navbar-collapse collapse',
                  'menu_class'      => 'nav',
                  'walker'          => new piemont_description_walker
                  ));  
              
              ?>
              </div>
          </div>
        </div>
    </div>
    <?php endif; ?>
    
    <?php
    // MainMenu Below header position END 
}

function piemont_header_left_show() {
    global $piemont_theme_options;

    // Show header banner
    if((isset($piemont_theme_options['header_banner_editor'])) && ($piemont_theme_options['header_banner_editor'] <> '') && (isset($piemont_theme_options['header_banner_position'])) && ($piemont_theme_options['header_banner_position'] == 'left')){
        piemont_header_promo_show();
    }

    if((isset($piemont_theme_options['header_logo_position'])) && ($piemont_theme_options['header_logo_position'] == 'left')) {
        piemont_logo_show();
    }
    
}

function piemont_header_center_show() {
    global $piemont_theme_options;

    if((isset($piemont_theme_options['header_logo_position'])) && ($piemont_theme_options['header_logo_position'] == 'center')) {
        piemont_logo_show();
    }
}

function piemont_header_right_show() {
    global $piemont_theme_options;

    if((isset($piemont_theme_options['header_logo_position'])) && ($piemont_theme_options['header_logo_position'] == 'right')) {
        piemont_logo_show();
    }

    // Show header banner
    if((isset($piemont_theme_options['header_banner_editor'])) && ($piemont_theme_options['header_banner_editor'] <> '') && (isset($piemont_theme_options['header_banner_position'])) && ($piemont_theme_options['header_banner_position'] == 'right')){
        piemont_header_promo_show();
    }

    // Demo settings
    if ( defined('DEMO_MODE') && isset($_GET['enable_offcanvas_sidebar']) ) {
      $piemont_theme_options['enable_offcanvas_sidebar'] = $_GET['enable_offcanvas_sidebar'];
    }

    ?>
    <ul class="header-nav">
        <?php
            if(isset($piemont_theme_options['enable_offcanvas_sidebar'])&&($piemont_theme_options['enable_offcanvas_sidebar'])): 
        ?>
        <li class="float-sidebar-toggle"><div id="st-sidebar-trigger-effects"><a class="float-sidebar-toggle-btn" data-effect="st-sidebar-effect-2"><i class="fa fa-bars"></i></a></div></li>
        <?php endif; ?>
    </ul>
<?php
}

function piemont_blog_slider_show() {

    global $piemont_theme_options, $post;

    // Demo settings
    if ( defined('DEMO_MODE') && isset($_GET['blog_homepage_slider_style']) ) {
      $piemont_theme_options['blog_homepage_slider_style'] = $_GET['blog_homepage_slider_style'];
    }
    if ( defined('DEMO_MODE') && isset($_GET['blog_homepage_slider_fullwidth']) ) {
      if($_GET['blog_homepage_slider_fullwidth'] == 1) {
        $piemont_theme_options['blog_homepage_slider_fullwidth'] = true;
      }
      if($_GET['blog_homepage_slider_fullwidth'] == 0) {
        $piemont_theme_options['blog_homepage_slider_fullwidth'] = false;
      }
    }

    $args = array(
        'posts_per_page'   => 0,
        'orderby'          => 'date',
        'order'            => 'DESC',
        'meta_key'         => '_post_featured_value',
        'meta_value'         => 'on',
        'post_type'        => 'post',
        'post_status'      => 'publish',
        'suppress_filters' => true 
    );

    $posts = get_posts( $args );

    $total_posts = sizeof($posts);

    if($total_posts > 0) {
        if(isset($piemont_theme_options['post_info_separator'])) {
            $post_info_separator = $piemont_theme_options['post_info_separator'];
        } else {
            $post_info_separator = '*';
        }

        if(isset($piemont_theme_options['blog_homepage_slider_autoplay'])) {
            $slider_style = $piemont_theme_options['blog_homepage_slider_style'];
        } else {
            $slider_style = 1;
        }

        $style = ' style="display: none;"';

        if($slider_style == 4) {
            $style = '';
        }

        if(isset($piemont_theme_options['blog_homepage_slider_autoplay'])) {
            $slider_autoplay = $piemont_theme_options['blog_homepage_slider_autoplay'];
        } else {
            $slider_autoplay = 1;
        }
        if(isset($piemont_theme_options['blog_homepage_slider_navigation'])) {
            $slider_navigation = $piemont_theme_options['blog_homepage_slider_navigation'];
        } else {
            $slider_navigation = 1;
        }
        if(isset($piemont_theme_options['blog_homepage_slider_pagination'])) {
            $slider_pagination = $piemont_theme_options['blog_homepage_slider_pagination'];
        } else {
            $slider_pagination = 1;
        }

        if($slider_autoplay == 1) {
            $slider_autoplay = 'true';
        } else {
            $slider_autoplay = 'false';
        }
        if($slider_navigation == 1) {
            $slider_navigation = 'true';
        } else {
            $slider_navigation = 'false';
        }
        if($slider_pagination == 1) {
            $slider_pagination = 'true';
        } else {
            $slider_pagination = 'false';
        }

        echo '<div class="piemont-post-list-wrapper piemont-post-wrapper-style-'.$slider_style.' clearfix">';

        
        echo '<div id="piemont-post-list" class="piemont-post-list piemont-post-style-'.$slider_style.'"'.$style.'>';

        $i = 0;

        foreach($posts as $post) {

            if($slider_style == 4) {
                if($i == 3) {
                    break;
                }
            }

            setup_postdata($post);

            echo '<div class="piemont-post">';

            if((isset($piemont_theme_options['blog_homepage_slider_fullwidth'])&&$piemont_theme_options['blog_homepage_slider_fullwidth']) && (isset($piemont_theme_options['blog_homepage_slider_style'])&&$piemont_theme_options['blog_homepage_slider_style'] < 3)) {
                $image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full');
            } else {
                $image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'blog-thumb');
            }

            if(has_post_thumbnail( $post->ID )) {
                $image_bg ='background-image: url('.$image[0].');';
            }
            else {
                $image_bg = '';
            }

            $categories_list = get_the_category_list( ', ' );

            // Get next post details for slider style 2
            if($slider_style == 2) {

                if($i == $total_posts-1) {
                    $next_post_data = $posts[0];
                    $next_post_class = ' last';
                } else {
                    $next_post_data = $posts[$i+1];
                    $next_post_class = '';
                }

                $next_image = wp_get_attachment_image_src( get_post_thumbnail_id( $next_post_data->ID ), 'blog-thumb');

                if(has_post_thumbnail( $next_post_data->ID )) {
                    $nextpost_image_bg ='background-image: url('.$next_image[0].');';
                } else {
                    $nextpost_image_bg ='';
                }

                $next_post_box_html = '<div class="piemont-next-post'.$next_post_class.'" data-style="'.esc_attr($nextpost_image_bg).'"><div class="piemont-next-post-text">'.__('Next', 'piemont').'</div></div>';
            } else {
                $next_post_box_html = '';
            }

            if(isset($piemont_theme_options['blog_post_show_author'])&&($piemont_theme_options['blog_post_show_author'])) {
                $author_info_html = $post_info_separator.' '.__('by ', 'piemont').get_the_author();
            } else {
                $author_info_html = '';
            }
            
            echo '<div class="piemont-post-image" data-style="'.esc_attr($image_bg).'"><div class="piemont-post-image-wrapper">
            <div class="piemont-post-details">
                <div class="piemont-post-box">'.$next_post_box_html.'</div>
                <div class="piemont-post-category">'.$categories_list.'</div>
                <div class="piemont-post-title"><a href="'.get_permalink($post->ID).'"><h2>'.esc_html($post->post_title).'</h2></a></div>
                <div class="piemont-post-date">'.get_the_time( get_option( 'date_format' ), $post->ID ).' '.$author_info_html.'</div>
                <div class="piemont-read-more"><a class="btn" href="'.get_permalink($post->ID).'">'.__('Read more', 'piemont').'</a></div>
            </div>
            </div></div>';

            echo '</div>';

            $i++;

        } 

        wp_reset_postdata();

        echo '</div>';
        echo '</div>';

        // Slider items per row
        $slider_slides = 1;

        if($slider_style == 3) {
            $slider_slides = 3;
        }

        if(in_array($slider_style, array(1,2,3))) {

            echo '<script>(function($){
            $(document).ready(function() {

                $("#piemont-post-list").owlCarousel({
                    items: '.esc_js($slider_slides).',
                    itemsDesktop:   [1199,'.esc_js($slider_slides).'],
                    itemsDesktopSmall: [979,1],
                    itemsTablet: [768,1],
                    itemsMobile : [479,1],
                    autoPlay: '.esc_js($slider_autoplay).',
                    navigation: '.esc_js($slider_navigation).',
                    navigationText : false,
                    pagination: '.esc_js($slider_pagination).',
                    afterInit : function(elem){
                        $(this).css("display", "block");
                    }
                });
                
                $(".piemont-post-list.piemont-post-style-2 .piemont-next-post").on("click", function(e){
                    $("#piemont-post-list").trigger("owl.next");
                });

                $(".piemont-post-list.piemont-post-style-2 .piemont-next-post.last").on("click", function(e){
                    $("#piemont-post-list").trigger("owl.goTo(1)");
                });
                
            });})(jQuery);</script>';
        }
    }

        
}

/* Homepage Welcome Block */
function piemont_welcome_block_show() {

    global $piemont_theme_options;

    if(isset($piemont_theme_options['blog_homepage_welcome_block_image']) && $piemont_theme_options['blog_homepage_welcome_block_image']['url'] <> '') {
        $welcome_block_has_image = true;
    } else {
        $welcome_block_has_image = false;
    }

    if($welcome_block_has_image) {
        echo '<div class="homepage-welcome-block homepage-welcome-block-with-image">';
    } else {
        echo '<div class="homepage-welcome-block">';
    }

    echo '<div class="homepage-welcome-block-content">';
    echo wp_kses_post($piemont_theme_options['blog_homepage_welcome_block_content']);
    echo '</div>';

    if($welcome_block_has_image) {
      echo '<div class="homepage-welcome-block-right-bg"></div>';
      echo '<div class="homepage-welcome-block-image"><img src="'.esc_url($piemont_theme_options['blog_homepage_welcome_block_image']['url']).'" alt="'.get_bloginfo('name').'" /></div>';
    }

    echo '</div>';

}

function piemont_welcome_block_2_show() {

    global $piemont_theme_options;

    echo '<div class="homepage-welcome-block-2">';
    
    echo '<div class="homepage-welcome-block-2-content">';
    echo wp_kses_post($piemont_theme_options['blog_homepage_welcome_block_2_content']);
    echo '</div>';

    echo '</div>';

}

/* Blog post excerpt read more */
function piemont_excerpt_more( $more ) {
    return '...';
}
add_filter('excerpt_more', 'piemont_excerpt_more');

/* Coming soon mode */
if(isset($piemont_theme_options['enable_comingsoon']) && $piemont_theme_options['enable_comingsoon']) {

    function piemont_maintenance_mode_check_msg() {   
        if(get_current_screen()->parent_base !== 'ipanel_PIEMONT_PANEL') {
             $msg = '<p><span style="color: red">The Maintenance/Coming soon Mode is active, your website is not visible for regular visitors.</span> Please don\'t forget to <a href="'.get_admin_url( '','admin.php?page=ipanel_PIEMONT_PANEL').'">deactivate it</a> when you will be ready to go live.</p>';
            echo '<div class="updated fade">'.wp_kses_post($msg).'</div>';
        }
    }

    if (is_admin()) {
        add_action('admin_notices', 'piemont_maintenance_mode_check_msg');
    }

    function piemont_toolbar_link_comingsoon( $wp_admin_bar ) {
        $args = array(
            'id'    => 'coming_soon_mode_active',
            'title' => 'Coming soon mode active',
            'href'  => get_admin_url( '','admin.php?page=ipanel_PIEMONT_PANEL'),
            'meta'  => array( 'class' => 'wpadminbar-coming-soon-active' )
        );
        $wp_admin_bar->add_node( $args );
    }
    add_action( 'admin_bar_menu', 'piemont_toolbar_link_comingsoon', 999 );

    if ( !is_admin_bar_showing() && !is_admin() ) {
        if (!current_user_can('edit_posts') && !in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ))) {

            function piemont_maintenance_mode_show() {

                $current_url_http = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
                $current_url_https = "https://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";

                $pages = get_pages(array(
                    'meta_key' => '_wp_page_template',
                    'meta_value' => 'coming-soon-page.php'
                ));

                if(($current_url_http !== get_permalink( $pages[0]->ID ))&&(($current_url_https !== get_permalink( $pages[0]->ID )))) {

                        wp_redirect( get_permalink( $pages[0]->ID ) );
                    exit;
                    
                }
                
            }

            add_action('init', 'piemont_maintenance_mode_show');

        }
    }
}

/* Custom widgets */

/**
 * Recent_Posts widget class
 */
class Piemont_Widget_Recent_Posts extends WP_Widget {

    public function __construct() {
        $widget_ops = array('classname' => 'widget_piemont_recent_entries', 'description' => __( "Your site&#8217;s most recent Posts with thumbnails.", 'piemont') );
        parent::__construct('piemont-recent-posts', __('Piemont Recent Posts', 'piemont'), $widget_ops);
        $this->alt_option_name = 'widget_piemont_recent_entries';

        add_action( 'save_post', array($this, 'flush_widget_cache') );
        add_action( 'deleted_post', array($this, 'flush_widget_cache') );
        add_action( 'switch_theme', array($this, 'flush_widget_cache') );
    }

    public function widget($args, $instance) {
        $cache = array();
        if ( ! $this->is_preview() ) {
            $cache = wp_cache_get( 'widget_piemont_recent_posts', 'widget' );
        }

        if ( ! is_array( $cache ) ) {
            $cache = array();
        }

        if ( ! isset( $args['widget_id'] ) ) {
            $args['widget_id'] = $this->id;
        }

        if ( isset( $cache[ $args['widget_id'] ] ) ) {
            echo $cache[ $args['widget_id'] ];
            return;
        }

        ob_start();

        $title = ( ! empty( $instance['title'] ) ) ? $instance['title'] : __( 'Recent Posts', 'piemont' );

        /** This filter is documented in wp-includes/default-widgets.php */
        $title = apply_filters( 'widget_title', $title, $instance, $this->id_base );

        $number = ( ! empty( $instance['number'] ) ) ? absint( $instance['number'] ) : 5;
        if ( ! $number )
            $number = 5;
        $show_date = isset( $instance['show_date'] ) ? $instance['show_date'] : false;
        $show_thumb = isset( $instance['show_thumb'] ) ? $instance['show_thumb'] : false;

        /**
         * Filter the arguments for the Recent Posts widget.
         *
         * @since 3.4.0
         *
         * @see WP_Query::get_posts()
         *
         * @param array $args An array of arguments used to retrieve the recent posts.
         */
        $r = new WP_Query( apply_filters( 'widget_piemont_posts_args', array(
            'posts_per_page'      => $number,
            'no_found_rows'       => true,
            'post_status'         => 'publish',
            'ignore_sticky_posts' => true
        ) ) );

        if ($r->have_posts()) :
?>
        <?php echo $args['before_widget']; ?>
        <?php if ( $title ) {
            echo $args['before_title'] . $title . $args['after_title'];
        } ?>
        <ul>
        <?php while ( $r->have_posts() ) : $r->the_post(); ?>
            <li class="clearfix">
            <?php if ( $show_thumb ) : ?>
                <a href="<?php the_permalink(); ?>"><?php the_post_thumbnail('blog-thumb-widget'); ?></a>
            <?php endif; ?>
            <div class="widget-post-details-wrapper">
                <a href="<?php the_permalink(); ?>"><?php get_the_title() ? the_title() : the_ID(); ?></a>
            <?php if ( $show_date ) : ?>
                <span class="post-date"><?php echo get_the_date(); ?></span>
            <?php endif; ?>
            </div>
            </li>
        <?php endwhile; ?>
        </ul>
        <?php echo $args['after_widget']; ?>
<?php
        // Reset the global $the_post as this query will have stomped on it
        wp_reset_postdata();

        endif;

        if ( ! $this->is_preview() ) {
            $cache[ $args['widget_id'] ] = ob_get_flush();
            wp_cache_set( 'widget_piemont_recent_posts', $cache, 'widget' );
        } else {
            ob_end_flush();
        }
    }

    public function update( $new_instance, $old_instance ) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['number'] = (int) $new_instance['number'];
        $instance['show_date'] = isset( $new_instance['show_date'] ) ? (bool) $new_instance['show_date'] : false;
        $instance['show_thumb'] = isset( $new_instance['show_thumb'] ) ? (bool) $new_instance['show_thumb'] : false;
        $this->flush_widget_cache();

        $alloptions = wp_cache_get( 'alloptions', 'options' );
        if ( isset($alloptions['widget_piemont_recent_entries']) )
            delete_option('widget_piemont_recent_entries');

        return $instance;
    }

    public function flush_widget_cache() {
        wp_cache_delete('widget_pieomnt_recent_posts', 'widget');
    }

    public function form( $instance ) {
        $title     = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
        $number    = isset( $instance['number'] ) ? absint( $instance['number'] ) : 5;
        $show_date = isset( $instance['show_date'] ) ? (bool) $instance['show_date'] : false;
        $show_thumb = isset( $instance['show_thumb'] ) ? (bool) $instance['show_thumb'] : false;
?>
        <p><label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php _e( 'Title:', 'piemont' ); ?></label>
        <input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

        <p><label for="<?php echo esc_attr($this->get_field_id( 'number' )); ?>"><?php _e( 'Number of posts to show:', 'piemont' ); ?></label>
        <input id="<?php echo esc_attr($this->get_field_id( 'number' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'number' )); ?>" type="text" value="<?php echo esc_attr($number); ?>" size="3" /></p>

        <p><input class="checkbox" type="checkbox" <?php checked( $show_date ); ?> id="<?php echo esc_attr($this->get_field_id( 'show_date' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'show_date' )); ?>" />
        <label for="<?php echo esc_attr($this->get_field_id( 'show_date' )); ?>"><?php _e( 'Display post date?', 'piemont' ); ?></label></p>

        <p><input class="checkbox" type="checkbox" <?php checked( $show_thumb ); ?> id="<?php echo esc_attr($this->get_field_id( 'show_thumb' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'show_thumb' )); ?>" />
        <label for="<?php echo esc_attr($this->get_field_id( 'show_thumb' )); ?>"><?php _e( 'Display post featured image?', 'piemont' ); ?></label></p>
<?php
    }
}

/**
 * Recent_Comments widget class
 *
 */
class Piemont_Widget_Recent_Comments extends WP_Widget {

    public function __construct() {
        $widget_ops = array('classname' => 'widget_piemont_recent_comments', 'description' => __( 'Your site&#8217;s most recent comments with date.', 'piemont' ) );
        parent::__construct('piemont-recent-comments', __('Piemont Recent Comments', 'piemont'), $widget_ops);
        $this->alt_option_name = 'widget_piemont_recent_comments';

        add_action( 'comment_post', array($this, 'flush_widget_cache') );
        add_action( 'edit_comment', array($this, 'flush_widget_cache') );
        add_action( 'transition_comment_status', array($this, 'flush_widget_cache') );
    }

    public function flush_widget_cache() {
        wp_cache_delete('widget_piemont_recent_comments', 'widget');
    }

    public function widget( $args, $instance ) {
        global $comments, $comment;

        $cache = array();
        if ( ! $this->is_preview() ) {
            $cache = wp_cache_get('widget_piemont_recent_comments', 'widget');
        }
        if ( ! is_array( $cache ) ) {
            $cache = array();
        }

        if ( ! isset( $args['widget_id'] ) )
            $args['widget_id'] = $this->id;

        if ( isset( $cache[ $args['widget_id'] ] ) ) {
            echo $cache[ $args['widget_id'] ];
            return;
        }

        $output = '';

        $title = ( ! empty( $instance['title'] ) ) ? $instance['title'] : __( 'Recent Comments', 'piemont' );

        /** This filter is documented in wp-includes/default-widgets.php */
        $title = apply_filters( 'widget_title', $title, $instance, $this->id_base );

        $number = ( ! empty( $instance['number'] ) ) ? absint( $instance['number'] ) : 5;
        if ( ! $number )
            $number = 5;

        /**
         * Filter the arguments for the Recent Comments widget.
         *
         * @since 3.4.0
         *
         * @see WP_Comment_Query::query() for information on accepted arguments.
         *
         * @param array $comment_args An array of arguments used to retrieve the recent comments.
         */
        $comments = get_comments( apply_filters( 'widget_comments_args', array(
            'number'      => $number,
            'status'      => 'approve',
            'post_status' => 'publish'
        ) ) );

        $output .= $args['before_widget'];
        if ( $title ) {
            $output .= $args['before_title'] . $title . $args['after_title'];
        }

        $output .= '<ul id="piemont_recentcomments">';
        if ( $comments ) {
            // Prime cache for associated posts. (Prime post term cache if we need it for permalinks.)
            $post_ids = array_unique( wp_list_pluck( $comments, 'comment_post_ID' ) );
            _prime_post_caches( $post_ids, strpos( get_option( 'permalink_structure' ), '%category%' ), false );

            foreach ( (array) $comments as $comment) {
                $output .= '<li class="piemont_recentcomments">';
                /* translators: comments widget: 1: comment author, 2: post link */
                $output .= '<a href="' . esc_url( get_comment_link( $comment->comment_ID ) ) . '">' . get_the_title( $comment->comment_post_ID ) . '</a><span class="comment-date">'.get_the_date().'</span>';
                
                $output .= '</li>';
            }
        }
        $output .= '</ul>';
        $output .= $args['after_widget'];

        echo $output; // This variable contains wordpress widget code and can't be escaped with WordPress functions 

        if ( ! $this->is_preview() ) {
            $cache[ $args['widget_id'] ] = $output;
            wp_cache_set( 'widget_piemont_recent_comments', $cache, 'widget' );
        }
    }

    public function update( $new_instance, $old_instance ) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['number'] = absint( $new_instance['number'] );
        $this->flush_widget_cache();

        $alloptions = wp_cache_get( 'alloptions', 'options' );
        if ( isset($alloptions['widget_piemont_recent_comments']) )
            delete_option('widget_piemont_recent_comments');

        return $instance;
    }

    public function form( $instance ) {
        $title  = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
        $number = isset( $instance['number'] ) ? absint( $instance['number'] ) : 5;
?>
        <p><label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php _e( 'Title:', 'piemont' ); ?></label>
        <input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

        <p><label for="<?php echo esc_attr($this->get_field_id( 'number' )); ?>"><?php _e( 'Number of comments to show:', 'piemont' ); ?></label>
        <input id="<?php echo esc_attr($this->get_field_id( 'number' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'number' )); ?>" type="text" value="<?php echo esc_attr($number); ?>" size="3" /></p>
<?php
    }
}

// Custom User social profiles
function piemont_add_to_author_profile( $contactmethods ) {

    $social_array = array('facebook' => 'Facebook', 'twitter' => 'Twitter', 'vk' => 'Vkontakte', 'google-plus' => 'Google Plus', 'behance' => 'Behance', 'linkedin' => 'LinkedIn', 'pinterest' => 'Pinterest', 'deviantart' => 'DeviantArt', 'dribbble' => 'Dribbble',  'flickr' => 'Flickr', 'instagram' => 'Instagram', 'skype' => 'Skype', 'tumblr' => 'Tumblr', 'twitch' => 'Twitch', 'vimeo-square' => 'Vimeo', 'youtube' => 'Youtube');
    
    foreach ($social_array as $social_key => $social_value) {
        # code...
        $contactmethods[$social_key.'_profile'] = $social_value.' Profile URL';
    }
    
    return $contactmethods;
}
add_filter( 'user_contactmethods', 'piemont_add_to_author_profile', 10, 1);
